* doc/autoconf.texi (Generic Compiler Characteristics): Fix typo
[autoconf/tsuna.git] / tests / mktests.sh
blobcc63aaf9ee009728dafcabdd8db808492941471a
1 #! /bin/sh
3 # Build some of the Autoconf test files.
5 # Copyright (C) 2000, 2001, 2002, 2003, 2004, 2005, 2006 Free Software
6 # Foundation, Inc.
8 # This program is free software; you can redistribute it and/or modify
9 # it under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 2, or (at your option)
11 # any later version.
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write to the Free Software
20 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
21 # 02110-1301, USA.
23 # If we fail, clean up, but touch the output files. We probably failed
24 # because we used some non-portable tool.
26 as_me=`echo "$0" | sed 's,.*[\\/],,'`
28 trap 'echo "'"$as_me"': failed." >&2
29 rm -f acdefuns audefuns requires *.tat
30 trap "" 0
31 exit 1' \
32 0 1 2 15
34 # If ever something goes wrong, fail, so that the trap is launched.
35 set -e
37 # We need arguments.
38 test $# != 0
40 # We need these arguments.
41 src="$@"
43 # Set locale to C so that `sort' behaves in a uniform way.
44 LANGUAGE=C; export LANGUAGE
45 LANG=C; export LANG
46 LC_ALL=C export LC_ALL
49 # requires
50 # --------
51 # Get the list of macros that are required: there is little interest
52 # in testing them since they will be run by the guy who requires them.
53 sed -n 's/dnl.*//;s/.*AC_REQUIRE(\[*\([a-zA-Z0-9_]*\).*$/\1/p' $src |
54 sort -u >requires
57 # exclude_list
58 # ------------
59 # Macros which must not be checked at all (not with AT_CHECK_MACRO nor
60 # AT_CHECK_AU_MACRO).
61 exclude_list='
62 # Not a macro name at all.
63 /^$/ {next}
65 # Not macros, just mapping from old variable name to a new one.
66 /^ac_cv_prog_(gcc|gxx|g77)$/ {next}
70 # ac_exclude_list
71 # ---------------
72 # We try to test all the Autoconf macros with AT_CHECK_MACRO to check
73 # for syntax problems, etc. Not every macros can be run without
74 # arguments, and some are already tested elsewhere. AC_EXCLUDE_LIST
75 # filters out the macros we don't want to test.
76 ac_exclude_list='
77 # Internal macros are used elsewhere.
78 /^_?_AC_/ {next}
80 # Used in many places.
81 /^AC_.*_IFELSE$/ {next}
82 /^AC_LANG/ {next}
83 /^AC_RUN_LOG$/ {next}
84 /^AC_TRY/ {next}
86 # Need an argument.
87 /^AC_(CANONICALIZE|PREFIX_PROGRAM|PREREQ)$/ {next}
88 /^AC_(SEARCH_LIBS|REPLACE_FUNCS)$/ {next}
89 /^AC_(CACHE_CHECK|COMPUTE)_INT$/ {next}
91 # Performed in the semantics tests.
92 /^AC_CHECK_(ALIGNOF|DECL|FILE|FUNC|HEADER|LIB|MEMBER|PROG|SIZEOF|(TARGET_)?TOOL|TYPE)S?$/ {next}
94 # Fail when the source does not exist.
95 /^AC_CONFIG/ {next}
97 # AU defined to nothing.
98 /^AC_(CYGWIN|CYGWIN32|EMXOS2|MING32|EXEEXT|OBJEXT)$/ {next}
100 # Produce "= val" because $1, the variable used to store the result,
101 # is empty.
102 /^AC_(F77|FC)_FUNC$/ {next}
103 /^AC_FC_SRCEXT$/ {next}
104 /^AC_PATH_((TARGET_)?TOOL|PROG)S?$/ {next}
106 # Requires the current language to be Fortran, not C.
107 /^AC_FC_FREEFORM$/ {next}
109 # Is a number.
110 /^AC_FD_CC$/ {next}
112 # Obsolete, but needs to be AC_DEFUNed.
113 /^AC_FOREACH$/ {next}
115 # Require a file that is not shipped with Autoconf. But it should.
116 /^AC_FUNC_(GETLOADAVG|FNMATCH_GNU)$/ {next}
117 /^AC_REPLACE_FNMATCH$/ {next}
119 # Obsolete, checked in semantics.
120 /^AC_FUNC_WAIT3$/ {next}
121 /^AC_FUNC_SETVBUF_REVERSED$/ {next}
122 /^AC_SYS_RESTARTABLE_SYSCALLS$/ {next}
124 # Not intended to be invoked at the top level.
125 /^AC_INCLUDES_DEFAULT$/ {next}
127 # AC_INIT includes all the AC_INIT macros.
128 # There is an infinite m4 recursion if AC_INIT is used twice.
129 /^AC_INIT/ {next}
131 # Checked in semantics.
132 /^AC_(PROG_CC|C_CONST|C_VOLATILE)$/ {next}
133 /^AC_PATH_XTRA$/ {next}
135 # Requires a working C++ compiler, which is not a given.
136 /^AC_PROG_CXX_C_O$/ {next}
138 # Already tested by AT_CHECK_MACRO.
139 /^AC_OUTPUT$/ {next}
143 # ac_exclude_script
144 # -----------------
145 # Build a single awk script out of the above.
146 ac_exclude_script="$exclude_list $ac_exclude_list {print}"
149 # au_exclude_list
150 # ---------------
151 # Check all AU_DEFUN'ed macros with AT_CHECK_AU_MACRO, except these.
152 au_exclude_list='
153 # Empty.
154 /^AC_(C_CROSS|PROG_CC_STDC)$/ {next}
156 # Use AC_REQUIRE.
157 /^AC_(CYGWIN|MINGW32|EMXOS2)$/ {next}
159 # Already in configure.ac.
160 /^AC_(INIT|OUTPUT)$/ {next}
162 # AC_LANG_SAVE needs user interaction to be removed.
163 # AC_LANG_RESTORE cannot be used alone.
164 /^AC_LANG_(SAVE|RESTORE)$/ {next}
166 # Need arguments and are tested elsewhere.
167 /^AC_(LINK_FILES|PREREQ)$/ {next}
170 # au_exclude_script
171 # -----------------
172 # Build a single awk script out of the above.
173 au_exclude_script="$exclude_list $au_exclude_list {print}"
176 ## ------------------------- ##
177 ## Creating the test files. ##
178 ## ------------------------- ##
180 for file in $src
182 base=`echo "$file" | sed 's,.*[\\/],,;s/\..*//'`
183 # Get the list of macros which are defined in Autoconf level.
184 # Get rid of the macros we are not interested in.
185 sed -n -e 's/^AC_DEFUN(\[*\([a-zA-Z0-9_]*\).*$/\1/p' \
186 -e 's/^AC_DEFUN_ONCE(\[*\([a-zA-Z0-9_]*\).*$/\1/p' $file |
187 awk "$ac_exclude_script" |
188 sort -u >acdefuns
190 # Get the list of macros which are defined in Autoupdate level.
191 sed -n 's/^AU_DEFUN(\[*\([a-zA-Z][a-zA-Z0-9_]*\).*$/\1/p' $file |
192 awk "$au_exclude_script" |
193 sort -u >audefuns
195 # Filter out required macros.
197 sed 's/^ *//' <<MK_EOF
198 # Generated by $as_me. -*- Autotest -*-
200 ## --------------------- ##
201 ## Do not edit by hand. ##
202 ## --------------------- ##
204 # Copyright (C) 2000, 2001, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
206 AT_BANNER([Testing autoconf/$base macros.])
208 MK_EOF
210 echo "# Modern macros."
211 comm -23 acdefuns requires | sed 's/.*/AT_CHECK_MACRO([&])/'
212 echo
213 echo "# Obsolete macros."
214 comm -23 audefuns requires | sed 's/.*/AT_CHECK_AU_MACRO([&])/'
215 } >ac$base.tat
217 # In one atomic step so that if something above fails, the trap
218 # preserves the old version of the file. If there is nothing to
219 # check, output /rien du tout/[1].
220 if grep AT_CHECK ac$base.tat >/dev/null 2>&1; then
221 mv -f ac$base.tat ac$base.at
222 else
223 rm -f ac$base.tat ac$base.at
224 touch ac$base.at
226 # Help people not to update these files by hand.
227 chmod a-w ac$base.at
228 done
230 rm -f acdefuns audefuns requires
232 trap '' 0
233 exit 0
235 # [1] En franc,ais dans le texte.